// app.js
import SlsTracker from '@aliyun-sls/web-track-mini';
import createStsPlugin from '@aliyun-sls/web-sts-plugin';

App({
  todos: [
    { text: 'Learning Javascript', completed: true },
    { text: 'Learning ES2016', completed: true },
    { text: 'Learning 支付宝小程序', completed: false },
  ],
  userInfo: null,
  tracker: null,

  onLaunch: function() {
    // 在应用启动时进行初始化
    this.initSlsTracker();
  },

  initSlsTracker: function() {
    const opts = {
      host: 'cn-shanghai.log.aliyuncs.com', // 替换为你的服务入口
      project: '${Project}', // 替换为你的 Project 名称
      logstore: '${Logstore}', // 替换为你的 Logstore 名称
      time: 10,
      count: 10,
      topic: 'topic',
      source: 'source',
      tags: {
        tags: 'tags',
      },
    };

    const stsOpt = {
      accessKeyId: '',
      accessKeySecret: '',
      securityToken: '',
      refreshSTSToken: () => new Promise((resolve, reject) => {
        my.request({
          url: 'http://${ECS实例的公网IP}/get_sts_token', // 替换为后端 STS Token 提供服务的真实地址
          method: 'GET',
          success: (res) => {
            if (res.statusCode === 200) {
              let credential;

              // 检查返回的数据类型确保是字符串，若不是字符串则可能已是对象
              if (typeof res.data === "string") {
                //解析为JSON对象
                credential = JSON.parse(res.data);
              } else {
                // 直接使用对象
                credential = res.data;
              }
              stsOpt.accessKeyId = credential.AccessKeyId;
              stsOpt.accessKeySecret = credential.AccessKeySecret;
              stsOpt.securityToken = credential.SecurityToken;
              resolve(credential);
            } else {
              reject(new Error('Failed to refresh STS token with status code: ' + res.statusCode));
            }
          },
          fail: (err) => {
            reject(new Error('Failed to refresh STS token', err));
          },
        });
      }),
    };

    const tracker = new SlsTracker(opts);
    const stsPlugin = createStsPlugin(stsOpt);
    tracker.useStsPlugin(stsPlugin);

    // 以单条日志上传为例，在小程序启动时会发送一条日志便于测试
    // tracker.send({
    //   eventType:'view_product',
    //   productName: 'Tablet',
    //   price: 500  
    // });


    this.tracker = tracker;
  },

  
});
