// todo.js
const app = getApp();

Page({
  // 声明页面数据
  data: {
    user: {}, // 初始化用户信息为空对象
    todos: [] // 初始化 todos 为空数组
  },
  
  
  // 监听生命周期回调 onShow
  onShow() {
    // 设置全局数据到当前页面数据
    this.setData({ todos: app.todos });
  },
  
  // 事件处理函数
  onTodoChanged(e) {
    // 修改全局数据
    const checkedTodos = e.detail.value;
    app.todos = app.todos.map(todo => ({
      ...todo,
      completed: checkedTodos.indexOf(todo.text) > -1,
    }));
    this.setData({ todos: app.todos });
  },


  handleAddTodo() {
    // 第一个操作: 添加一个新的待办事项
    this.addTodo();
    // 第二个操作: 发送日志消息
    this.onAddTodoButtonClick();
  },
  
  addTodo() {
    // 进行页面跳转
    my.navigateTo({ url: '/pages/add-todo/add-todo' });
  },
  

  onAddTodoButtonClick() {
    // 用户点击 addtodo 按钮，上传日志
    if (app.tracker) {
      app.tracker.send({
        eventType: 'addtodo_click',
        // 可以添加其他需要上报的字段
      });
    }
  },


});
